var express = require('express');
var app = express();
let bodyParser = require('body-parser');
var bcrypt = require('bcrypt-nodejs');


var flash    = require('connect-flash');
const saltRounds = 10;
const myPlaintextPassword = 's0/\/\P4$$w0rD';
const someOtherPlaintextPassword = 'not_bacon';

var passport = require('passport')
var LocalStrategy = require('passport-local').Strategy;

app.use(require('cookie-parser')());
app.use(require('express-session')({ secret: 'keyboard cat', resave: true, saveUninitialized: true }));
app.use(bodyParser.urlencoded({ extended: false }))
app.use(bodyParser.json())

app.use(passport.initialize());
app.use(passport.session());
app.use(flash())

let connection = require("../config/database")

passport.use(
    'local-signup',
    new LocalStrategy({
      // by default, local strategy uses username and password, we will override with email
      usernameField: 'username',
      passwordField: 'password',
      passReqToCallback: true // allows us to pass back the entire request to the callback
    },
      function (req, username, password, done) {
        // find a user whose email is the same as the forms email
        // we are checking to see if the user trying to login already exists
        connection.query("SELECT * FROM users WHERE username = ?", [username], function (err, rows) {
          if (err)
            return done(err);
          if (rows.length) {
            return done(null, false, null);
          } else {
            // if there is no user with that username
            // create the user
            var newUserMysql = {
              username: username,
              password: bcrypt.hashSync(password, null, null)  // use the generateHash function in our user model
            };
  
            var insertQuery = "INSERT INTO users ( username, password ) values (?,?)";
  
            connection.query(insertQuery, [newUserMysql.username, newUserMysql.password], function (err, rows) {
  
              newUserMysql.id = rows.insertId;
              return done(null, newUserMysql);
            });
          }
        });
      })
  );


  passport.use(
    'local-login',
    new LocalStrategy({
      // by default, local strategy uses username and password, we will override with email
      usernameField: 'username',
      passwordField: 'password',
      passReqToCallback: true // allows us to pass back the entire request to the callback
    },
      function (req, username, password, done) { // callback with email and password from our form
        connection.query("SELECT * FROM users WHERE username = ?", [username], function (err, rows) {
          if (err)
            return done(err);
          if (!rows.length) {
            return done(null, false, req.flash('loginMessage', 'No user found.')); // req.flash is the way to set flashdata using connect-flash
          }
  
          // if the user is found but the password is wrong
          if (!bcrypt.compareSync(password, rows[0].password))
            return done(null, false, req.flash('loginMessage', 'Oops! Wrong password.')); // create the loginMessage and save it to session as flashdata
  
          // all is well, return successful user
          return done(null, rows[0]);
        });
      })
  );
  
  
  
  
  passport.serializeUser(function (user, done) {
    done(null, user.id);
  });
  
  // used to deserialize the user
  passport.deserializeUser(function (id, done) {
    connection.query("SELECT * FROM users WHERE id = ? ", [id], function (err, rows) {
      done(err, rows[0]);
    });
  });



  module.exports = passport